/************************************************************************************************************
 **   GEMM - a generic mobility model  for generating realistic mobility scenarios                                          
 **   Copyright (C) 2003, 2004 Suprio Ray
 **   Copyright (C) 2003, 2004 University of British Columbia, Canada                             
 **                                                                           
 ** This program is free software; you can redistribute it and/or modify      
 ** it under the terms of the GNU General Public License as published by      
 ** the Free Software Foundation; either version 2 of the License, or         
 ** (at your option) any later version.                                       
 **                                                                           
 ** This program is distributed in the hope that it will be useful,           
 ** but WITHOUT ANY WARRANTY; without even the implied warranty of           
 ** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the            
 ** GNU General Public License for more details.                              
 **                                                                           
 ** You should have received a copy of the GNU General Public License        
 ** along with this program; if not, write to the Free Software             
 ** Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA 
 *************************************************************************************************************/

/**  Activity.java
 *  @description 
 *  @author  Suprio Ray
 *  @date  Sept. 03, 2003
 *  @version GEMM 1.0
 */
package ca.ubc.cs. gemm;


public class Activity {
	double triggerTimeMax;
	double triggerTimeMin;
	double actDurationMax;
	double actDurationMin;
	double attractionPointToGoTo;
	double activityType;
	
	double lastTimePerformed;
	
	Activity(double ttMax, double ttMin, double adMax, double adMin, double aptgt, double aType) {
		 triggerTimeMax = ttMax;
		 triggerTimeMin = ttMin;
		 actDurationMax = adMax;
		 actDurationMin = adMin;
		 attractionPointToGoTo =  aptgt;
		 activityType = aType;
	
		 lastTimePerformed =0;	 
	}
	Activity(Activity a) {
		this.triggerTimeMax = a.triggerTimeMax;
		this.triggerTimeMin = a.triggerTimeMin;
		this.actDurationMax = a.actDurationMax;
		this.actDurationMin = a.actDurationMin;
		this.attractionPointToGoTo =  a.attractionPointToGoTo;
		this.activityType = a.activityType;
	
		this.lastTimePerformed = a.lastTimePerformed ;
	}
	public double getLastTimePerformed() {
		return lastTimePerformed;
	}
	public void setLastTimePerformed(double d) {
		lastTimePerformed = d;
	}
	
	public boolean matches(double aType) {
		return (aType == activityType);
	}
	public double getAttractionPointToGo() {
		return attractionPointToGoTo;
		
	}
	
	public double getMaxTriggerTime() {
		return triggerTimeMax;
	}
	public double getMinTriggerTime() {
		return triggerTimeMin;	
	}
	
	public double getMaxActDuration() {
		return actDurationMax;
	}
	public double getMinActDuration() {
		return actDurationMin;
	}
	
	public double getActivityType() {
		return activityType;
	}
	
	public static double NO_PARTICULAR_ATTRACTION_POINT = -1; 
	public static double RANDOM_DIRECTION = -2;
}
