/************************************************************************************************************
 **   GEMM - a generic mobility model  for generating realistic mobility scenarios                                          
 **   Copyright (C) 2003, 2004 Suprio Ray
 **   Copyright (C) 2003, 2004 University of British Columbia, Canada                             
 **                                                                           
 ** This program is free software; you can redistribute it and/or modify      
 ** it under the terms of the GNU General Public License as published by      
 ** the Free Software Foundation; either version 2 of the License, or         
 ** (at your option) any later version.                                       
 **                                                                           
 ** This program is distributed in the hope that it will be useful,           
 ** but WITHOUT ANY WARRANTY; without even the implied warranty of           
 ** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the            
 ** GNU General Public License for more details.                              
 **                                                                           
 ** You should have received a copy of the GNU General Public License        
 ** along with this program; if not, write to the Free Software             
 ** Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA 
 *************************************************************************************************************/

/**  GemmMobileNode.java
 *  @description 
 *  @author  Suprio Ray
 *  @date  Sept. 03, 2003
 *  @version GEMM 1.0
 */
package ca.ubc.cs. gemm;

import java.util.*;

import edu.bonn.cs.iv.bonnmotion.*;


public class GemmMobileNode extends MobileNode {
 
 double  dst =0;
 
  // osci
  public boolean osci =false;
  public Position origPos = null;
  public Activity osciAct; 
 
	Role role;
	Activity curAct;
	
	boolean isactive; 
	boolean targetReached;
	
	double curTime, dir, speed, actDur;
	Position targetDst;
	Position curPos;
	
	// group mobility 
	boolean CollisionAvoidance; 
	boolean Groupcentering; 
	boolean VelocityMatching;
	boolean Inertia;
	
		
	ArrayList collsionNbrList = null;
	ArrayList  nearbyNbrList = null;
	ArrayList grpNbrList  = null;
	
	static final int COLLISION_RANGE = 1;
	static final int SENSITIVITY_ZONE = 5;
	static final int  GROUP_RANGE = 50;   
	static final double INERTIA_BOUND = 3;
		
	public GemmMobileNode() {
		super();
	}
	
	public void setRole(Role r) {
		role = r;
	}
	public Role getRole() {
		
		return role;
	}
	
	public void setCurActivity(Activity act) {
		curAct = act;
	}
	public Activity getCurActivity() {
		return curAct;
	}
	
	public boolean isActive() {
		return isactive;
	}
	public void setActive(boolean b) {
		isactive = b;
	}
	
    /* 
	public boolean isInMotion() {
		return inmotion;
	}
	public void setInMotion(boolean b) {
		inmotion =b;
	}
	*/
	
	public void setCurTime(double t) {
		curTime=t;
	}
	public double getCurTime() {
		return curTime;
	}

	public void setTargetDst(Position td) {
		targetDst = td;
		targetReached = false;
	}
	public Position getTargetDst() {
		return  targetDst;
	}
		
	public void setTargetReached() {
		targetReached = true;
	}
	public boolean isTargetReached() {
		return targetReached;
	}
	
	public boolean isTargetSet() {
	 		return (targetDst != null);
	}
	public void setNoTarget() {
			targetDst = null;
	}
		
	public void setCurPos(Position cp) {
		curPos= cp;
	}
	public Position getCurPos() {
			return curPos;
	}

	public void setDir(double dir) {
		this.dir =dir;
	}
	public double getDir() {
	 	return dir;
	}

	public void setSpeed(double speed) {
		this.speed=speed;
	}
	public double getSpeed() {
		return speed;
	}

	public double getActivityDuration() {
		return actDur;
	}
	public void setActivityDuration(double d) {
		actDur =d;
	}
	/* 
	public void setOriginalSrc(Position os) {
		originalSrc=os;
	}
	public Position getOriginalSrc() {
		return originalSrc;
	} */
	
}
